<?php
/*
 Plugin Name: Wareki Day Widget
 Plugin URI: http://usort.jp/wareki-day-widget
 Description: 今日の日付を和暦で表示するウィジェット
 Author: Usort Umoto
 Version: 1.0
 Author URI: http://usort.jp/
*/
//ウィジェット生成用アクションフィルタ
add_action('widgets_init', create_function('', 'return register_widget("WarekiDayWidget");'));


class WarekiDayWidget extends WP_Widget{
    /**
     * Widgetを登録する
     */
    function __construct() {
        parent::__construct(
            'wareki_day_widget', // Base ID
            '本日を和暦で表示', // Name
            array( 'description' => '本日を和暦で表示します', ) // Args
        );
    }

 
    /**
     * 表側の Widget を出力する
     *
     * @param array $args      'register_sidebar'で設定した「before_title, after_title, before_widget, after_widget」が入る
     * @param array $instance  Widgetの設定項目
     */
    public function widget( $args, $instance ) {
		date_default_timezone_set('Asia/Tokyo');
		$api = 'http://koyomi.zing2.org/api/';
		 $param = array(
		 	 'mode' => "d"
		 	,'cnt'  => "1"
		 	,'targetyyyy' => date("Y")
		 	,'targetmm' => date("m")
		 	,'targetdd' => date("d")
		);
		$ch = curl_init($api);
		## パラメータを設定
		curl_setopt($ch, CURLOPT_URL, $api);
		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
		curl_setopt($ch, CURLOPT_HTTPPROXYTUNNEL, TRUE);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
		curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($param));

		## 結果を取得
		$result = curl_exec($ch);
		## コネクション切断
		curl_close($ch);

		## 連想配列にデコード
		$data = json_decode($result, true);
		## データ取得
		$date = $data{'datelist'}{date("Y-m-d")};

		// css
		$widget_content .= '
			<style type="text/css">
				div.wareki-day-widget {
				text-align:left;
				font-size:0.8rem;
			  }

				div.wareki-day-widget-ym {
				text-align:right;
				font-size:1rem;
			  }
			</style>
		';

		$widget_content .= "<div class=\"wareki-day-widget\">".$date{'gengo'}.$date{'wareki'};
		if ($instance['seireki'] == true){
			$widget_content .= "(".date('Y').")";
		}
		$widget_content .= "年</div>";
		if (($instance['hiduke'] == true) OR ($instance['youbi'] == true)){
			$widget_content .= "<div class=\"wareki-day-widget-ym\">";
			if ($instance['hiduke'] == true){
				$widget_content .= date('n')."月".date('j')."日&nbsp;";
			}
			if ($instance['youbi'] == true){
				$widget_content .= "(". $date{'week'} .")";
			}
			$widget_content .= "</div>";
		}
		if (($instance['inreki'] == true) OR ($instance['sekki'] == true) OR ($instance['rokuyou'] == true) OR ($instance['zyusi'] == true) OR ($instance['zyunisi'] == true)){
			$widget_content .= "<div class=\"wareki-day-widget\">";
			if ($instance['inreki'] == true) {
				$widget_content .= $date{'inreki'}."<br />";
			}
			if (($instance['sekki'] == true) OR ($instance['rokuyou'] == true) OR ($instance['zyusi'] == true) OR ($instance['zyunisi'] == true)){
				$widget_content .= "<span style=\"line-height: 1em;\">";
				if ($instance['sekki'] == true) {
					$widget_content .= $date{'sekki'}. "&nbsp;";
				}
				if ($instance['rokuyou'] == true) {
					$widget_content .= $date{'rokuyou'}. "&nbsp;";
				}
				if ($instance['zyusi'] == true) {
					$widget_content .= $date{'zyusi'}. "&nbsp;";
				}
				if ($instance['zyunisi'] == true) {
					$widget_content .= $date{'zyunisi'};
				}
				$widget_content .= "</span>";
			}
			$widget_content .= "</div>";
		}
		if (($instance['kyurekimd'] == true) OR ($instance['holiday'] == true)){
			$widget_content .= "<div class=\"wareki-day-widget\">";
			if ($instance['kyurekimd'] == true) {
				$widget_content .= "旧" .  $date{'kyurekim'}."月".$date{'kyurekid'} . "日<br />";
			}
			if ($instance['holiday'] == true) {
				$widget_content .= $date{'holiday'};
			}
			$widget_content .= "</div>";
		}
        extract( $args );
        $title = apply_filters('widget_title', $instance['title']);

		if ( $title ) {
			$disp_title = $args['before_title'] . $title . $args['after_title'];
		}
	echo <<<EOS
              {$before_widget}
              {$disp_title}
              {$widget_content}
              {$after_widget}
EOS;
    }

 
    /** Widget管理画面を出力する
     *
     * @param array $instance 設定項目
     * @return string|void
     */
    public function form( $instance ){
		$title     = isset( $instance['title'] ) ? esc_attr( $instance['title'] ) : '';
?>
		<p><label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:' ); ?></label>
		<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo $title; ?>" /></p>
<?php
		$seireki = isset( $instance['seireki'] ) ? (bool) $instance['seireki'] : false;
		$title = apply_filters( 'widget_title', $title, $instance, $this->id_base );
        ?>
		<div>表示する項目にチェック</div>
        <p>
<input class="checkbox" type="checkbox"<?php checked( $seireki ); ?> id="<?php echo $this->get_field_id( 'seireki' ); ?>" name="<?php echo $this->get_field_name( 'seireki' ); ?>" />

            <label for="<?php echo $seireki_id; ?>">西暦</label>
<label for="<?php echo $this->get_field_id( 'seireki' ); ?>"></label></p>
        <?php
		$hiduke = isset( $instance['hiduke'] ) ? (bool) $instance['hiduke'] : false;
        ?>
        <p>
<input class="checkbox" type="checkbox"<?php checked( $hiduke ); ?> id="<?php echo $this->get_field_id( 'hiduke' ); ?>" name="<?php echo $this->get_field_name( 'hiduke' ); ?>" />

            <label for="<?php echo $hiduke_id; ?>">日付</label>
<label for="<?php echo $this->get_field_id( 'hiduke' ); ?>"></label></p>
        <?php
		$youbi = isset( $instance['youbi'] ) ? (bool) $instance['youbi'] : false;
        ?>
        <p>
<input class="checkbox" type="checkbox"<?php checked( $youbi ); ?> id="<?php echo $this->get_field_id( 'youbi' ); ?>" name="<?php echo $this->get_field_name( 'youbi' ); ?>" />

            <label for="<?php echo $youbi_id; ?>">曜日</label>
<label for="<?php echo $this->get_field_id( 'youbi' ); ?>"></label></p>
        <?php
		$inreki = isset( $instance['inreki'] ) ? (bool) $instance['inreki'] : false;
        ?>
        <p>
<input class="checkbox" type="checkbox"<?php checked( $inreki ); ?> id="<?php echo $this->get_field_id( 'inreki' ); ?>" name="<?php echo $this->get_field_name( 'inreki' ); ?>" />

            <label for="<?php echo $inreki_id; ?>">陰暦</label>
<label for="<?php echo $this->get_field_id( 'inreki' ); ?>"></label></p>
        <?php
		$sekki = isset( $instance['sekki'] ) ? (bool) $instance['sekki'] : false;
        ?>
        <p>
<input class="checkbox" type="checkbox"<?php checked( $sekki ); ?> id="<?php echo $this->get_field_id( 'sekki' ); ?>" name="<?php echo $this->get_field_name( 'sekki' ); ?>" />

            <label for="<?php echo $sekki_id; ?>">節季</label>
<label for="<?php echo $this->get_field_id( 'sekki' ); ?>"></label></p>
        <?php
		$rokuyou = isset( $instance['rokuyou'] ) ? (bool) $instance['rokuyou'] : false;
        ?>
        <p>
<input class="checkbox" type="checkbox"<?php checked( $rokuyou ); ?> id="<?php echo $this->get_field_id( 'rokuyou' ); ?>" name="<?php echo $this->get_field_name( 'rokuyou' ); ?>" />

            <label for="<?php echo $rokuyou_id; ?>">六曜</label>
<label for="<?php echo $this->get_field_id( 'rokuyou' ); ?>"></label></p>
        <?php
		$zyusi = isset( $instance['zyusi'] ) ? (bool) $instance['zyusi'] : false;
        ?>
        <p>
<input class="checkbox" type="checkbox"<?php checked( $zyusi ); ?> id="<?php echo $this->get_field_id( 'zyusi' ); ?>" name="<?php echo $this->get_field_name( 'zyusi' ); ?>" />

            <label for="<?php echo $zyusi_id; ?>">十支</label>
<label for="<?php echo $this->get_field_id( 'zyusi' ); ?>"></label></p>
        <?php
		$zyunisi = isset( $instance['zyunisi'] ) ? (bool) $instance['zyunisi'] : false;
        ?>
        <p>
<input class="checkbox" type="checkbox"<?php checked( $zyunisi ); ?> id="<?php echo $this->get_field_id( 'zyunisi' ); ?>" name="<?php echo $this->get_field_name( 'zyunisi' ); ?>" />

            <label for="<?php echo $zyunisi_id; ?>">十二支</label>
<label for="<?php echo $this->get_field_id( 'zyunisi' ); ?>"></label></p>
        <?php
		$kyurekimd = isset( $instance['kyurekimd'] ) ? (bool) $instance['kyurekimd'] : false;
        ?>
        <p>
<input class="checkbox" type="checkbox"<?php checked( $kyurekimd ); ?> id="<?php echo $this->get_field_id( 'kyurekimd' ); ?>" name="<?php echo $this->get_field_name( 'kyurekimd' ); ?>" />

            <label for="<?php echo $kyurekimd_id; ?>">旧暦年月</label>
<label for="<?php echo $this->get_field_id( 'kyurekimd' ); ?>"></label></p>
        <?php
		$holiday = isset( $instance['holiday'] ) ? (bool) $instance['holiday'] : false;
        ?>
        <p>
<input class="checkbox" type="checkbox"<?php checked( $holiday ); ?> id="<?php echo $this->get_field_id( 'holiday' ); ?>" name="<?php echo $this->get_field_name( 'holiday' ); ?>" />

            <label for="<?php echo $holiday_id; ?>">祝日</label>
<label for="<?php echo $this->get_field_id( 'holiday' ); ?>"></label></p>
        <?php
    }
 
    /** ウィジェット設定画面で選ばれた内容を保存する
     *
     * @param array $new_instance  form()から入力された新しい設定データ
     * @param array $old_instance  前回の設定データ
     * @return array               保存（更新）する設定データ。falseを返すと更新しない。
     */
    function update($new_instance, $old_instance) {
		$instance['title'] = sanitize_text_field( $new_instance['title'] );
		$instance['seireki'] = isset( $new_instance['seireki'] ) ? (bool) $new_instance['seireki'] : false;
		$instance['hiduke'] = isset( $new_instance['hiduke'] ) ? (bool) $new_instance['hiduke'] : false;
		$instance['youbi'] = isset( $new_instance['youbi'] ) ? (bool) $new_instance['youbi'] : false;
		$instance['inreki'] = isset( $new_instance['inreki'] ) ? (bool) $new_instance['inreki'] : false;
		$instance['sekki'] = isset( $new_instance['sekki'] ) ? (bool) $new_instance['sekki'] : false;
		$instance['rokuyou'] = isset( $new_instance['rokuyou'] ) ? (bool) $new_instance['rokuyou'] : false;
		$instance['zyusi'] = isset( $new_instance['zyusi'] ) ? (bool) $new_instance['zyusi'] : false;
		$instance['zyunisi'] = isset( $new_instance['zyunisi'] ) ? (bool) $new_instance['zyunisi'] : false;
		$instance['kyurekimd'] = isset( $new_instance['kyurekimd'] ) ? (bool) $new_instance['kyurekimd'] : false;
		$instance['holiday'] = isset( $new_instance['holiday'] ) ? (bool) $new_instance['holiday'] : false;
        return $instance;
    }
}
 
